Viewing Issue Advanced Details Jump to Notes ] [ View Source: system1.c ]
ID Category [?] Severity [?] Reproducibility Date Submitted Last Update
04558 Gameplay Minor Always 2011-12-14 20:37 2013-12-21 17:28
Tester pri88 View Status Public Platform MAMEUI
Assigned To hap Resolution Fixed OS Windows XP (32-bit)
Status [?] Resolved   Driver system1.c
Version 0.144u2 Fixed in Version 0.144u4 Build
Summary 04558: wboy and clones: 'gameplay smoothness' issue
Description this issue has existed since mame 0.131

code changes between mame versions 0.130 and 0.131 had an affect on wonderboy and clones, seemingly due to a lot of work done on the sega system 1 driver (mainly a rewrite). i only play wonderboy with a version of mame which was compiled before these code changes, because visually it runs 'smoother' (explained below).
Steps To Reproduce (note: this test below is not the only place where the 'lack of smoothness' in the game can be seen, but it gives a very good example of what i am trying to demonstrate).

try this test below with mame version 0.130 or earlier, and then with mame version 0.131 or later, to see the 'gameplay smoothness' difference for yourself:

1. load wonderboy (or a clone)
2. do not insert any coins/do not start a game
3. after waiting for 1 minute, the attract mode begins, where you are shown a demonstration of the game (level 1)
4. wonderboy runs along, collects a weapon (axe), kills a few snails...
5. now wonderboy reaches a grey rock on the floor, which he jumps over.
6. ok, now is where you want to pay attention and look closely. wonderboy now reaches two more rocks which are close together (see pic below). watch these two rocks as wonderboy jumps over them. in mame versions 130 or earlier, the rocks scroll by smoothly as the screen moves along. however, in mame 131 or later, the rocks judder/shake/jerk as wonderboy passes by (seemingly like they are not fixed properly to the background).

to repeat what i said earlier, this is not the only instance in the game where game objects (eg. rocks and other graphics) seem to wobble around 'out of sync' with the background/general pace of the game. this is just an example of where it is easy to notice the issue. note: i probably should also mention that this 'smoothness' issue also happens when you actually play the game itself. this is not just an issue with the game 'attract mode'.
Additional Information additional notes:
the following list below are things which do not affect/change the outcome of the tests:

vsync on/off
triple buffer on/off
fullscreen mode
window mode
direct3d mode
directdraw mode

added note:
in mame 0.130 and previous, wonderboy is listed as 60Hz
in mame 0.131 and onwards, wonderboy is listed as 60.096154Hz
(note: i also performed these tests using cabmame (which force all games to run at exactly 60hz). the test results did not change).

_________________________________________________________


Official Source Change Notes:
-------------------------------------------

0.130u4
-------
Corrected System 1 Z80 clocking: [Aaron Giles]
 * each opcode fetch is 2 cycles with /M1 low, so each byte of
    opcode fetching causes slightly longer delays than the previous
    tables
 * implemented approximate wait state timing for videoram access;
    further accuracy will rely on getting a dump of the PAL16R4
    that controls the horizontal video timing

Small System 1 update: [Aaron Giles]
 * correct video timing
 * removed "small" video drivers for games that properly mask the
    scrolling areas



0.130u3
-------
Sega System 1/2 rewrite: [Aaron Giles]
 * accurate collision detection in all games
 * correct full memory maps
 * hooked up 8255 and Z80 PIO correctly
 * unified many hacked variants into common hardware models
 * proper mixing using the mixing PROM
 * converted to tilemaps
 * fixed shtngmst sprites
 * correct Z80 timing
 * proper sound interrupt signaling and feedback
 * full description of video hardware
 * proper input hookup in dakkochn
 * cleaned up rendering code
 * fixed cocktail mode in pretty much all games
 * fixed stuck sprites in some games
 * partial 8751 simulation for choplift
 * proper global muting (attract sound off works in older games)
 * yes, the Pitfall 2 title is missing; more work to be done
Flags
Regression Version
Affected Sets / Systems wboy and clones
Attached Files
png file icon pic.png (14,612 bytes)  2011-12-14 20:37 by pri88
pri88

- Relationships
related to 04736Closed wboy, choplift, many others: screen resolution incorrect for system1 sets like wonder boy or choplifter 

-  Notes
User avatar (07974)
hap (Developer)
2011-12-16 03:14
edited on: 2011-12-17 01:39

sprite vs background alignment affects some other games in system1.c too, for example:
- regulus: see attract mode turrets and other ground objects
- brain: attract mode, not as bad as regulus though

**edited, will make a separate bugreport for this soon**

User avatar (07975)
hap (Developer)
2011-12-16 03:59

ok, it should be smoother in the next version, but still not completely correct
User avatar (07977)
pri88 (Viewer)
2011-12-16 18:06

many thanks that's really nice news :)
User avatar (07980)
hap (Developer)
2011-12-17 01:38

In fact, it's completely fixed in the next version! =)
brain/regulus bug is not related to this, report can be closed..
User avatar (07981)
pri88 (Viewer)
2011-12-17 02:01

that's bloody fantastic, i cant wait to try it

i will be watching those damn rocks again in excitement lol

merry xmas friend! best wishes :)))
User avatar (10084)
haynor666 (Tester)
2013-12-20 12:06

At least Brain is still jerky at times. Less noticable (for me) in Regulus. Could this be fixed just like Wonder Boy?
The old bug 4577 regarding sprite off versus rest is still valid as well.
User avatar (10086)
Stiletto (Developer)
2013-12-21 17:28

Wonderboy confirmed fine on PCB recording, for those who thought of it (see 01:10 or so)